SystemOrganization addCategory: #'Seaside-JSON-Examples'!

WAJsonComponent subclass: #WAJsonCalledComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Examples'!

!WAJsonCalledComponent methodsFor: 'rendering' stamp: 'pmm 9/24/2011 11:44'!
renderContentOn: json
	json object: [
		json key: 'message' value: 'answerer'.
		json key: 'actions' value: [
			json object: [
				json
					key: 'answer' value: [
						json callback: [ self answer ] ] ] ] ]! !

WAJsonComponent subclass: #WAJsonCallingComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Examples'!

!WAJsonCallingComponent class methodsFor: 'initialization' stamp: 'pmm 9/24/2011 11:45'!
register
	WAJsonAdmin register: self asApplicationAt: 'examples/json-call'! !

!WAJsonCallingComponent methodsFor: 'rendering' stamp: 'pmm 9/24/2011 11:44'!
renderContentOn: json
	json object: [
		json key: 'message' value: 'caller'.
		json key: 'actions' value: [
			json object: [
				json
					key: 'call' value: [
						json callback: [ self call: WAJsonCalledComponent new ] ] ] ] ]! !

WAJsonComponent subclass: #WAJsonCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Examples'!

!WAJsonCounter class methodsFor: 'initialization' stamp: 'pmm 9/24/2011 10:57'!
register
	WAJsonAdmin register: self asApplicationAt: 'examples/json-counter'! !

!WAJsonCounter methodsFor: 'actions' stamp: 'pmm 9/24/2011 10:58'!
decrease
	count := count - 1! !

!WAJsonCounter methodsFor: 'actions' stamp: 'pmm 9/24/2011 10:58'!
increase
	count := count + 1! !

!WAJsonCounter methodsFor: 'initialization' stamp: 'pmm 9/24/2011 10:58'!
initialize
	super initialize.
	count := 0! !

!WAJsonCounter methodsFor: 'rendering' stamp: 'pmm 9/24/2011 11:23'!
renderContentOn: json
	json object: [
		json key: 'count' value: count.
		json key: 'actions' value: [
			json object: [
				json
					key: 'increase' value: [
						json callback: [ self increase ] ];
					key: 'decrease' value: [
						json callback: [ self decrease ] ] ] ] ]! !

WAJsonComponent subclass: #WAJsonMultiCounter
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Examples'!

!WAJsonMultiCounter class methodsFor: 'initialization' stamp: 'pmm 9/24/2011 11:26'!
register
	WAJsonAdmin register: self asApplicationAt: 'examples/json-multicounter'! !

!WAJsonMultiCounter methodsFor: 'accessing' stamp: 'pmm 9/24/2011 11:26'!
children
	^ counters! !

!WAJsonMultiCounter methodsFor: 'initialization' stamp: 'pmm 9/24/2011 11:27'!
initialize
	super initialize.
	counters := (1 to: 5) collect: [ :each | WAJsonCounter new ]! !

!WAJsonMultiCounter methodsFor: 'rendering' stamp: 'pmm 9/24/2011 11:29'!
renderContentOn: json
	json array: [
		counters do: [ :each |
			json render: each ] ]! !
